/* VisPro/REXX */

call RxFuncAdd 'VpLoadFuncs', 'VpRexx', 'VpLoadFuncs'
call VpLoadFuncs

parse source . . _VPMacroName
_VPAppHandle = VpInit(_VPMacroName)
drop _VPMacroName
if _VPAppHandle='' then exit
_VPAppReturn = 0

/* Open first form */
Parse arg topic
_VPMainWindow = VpOpenForm('', 256, topic)
if _VPMainWindow='' then do
   call VpMessageBox 0,'VisPro/REXX','Unable to open Main form.  Verify that there is a Main form, that it has an id of 256, and that the form has controls within it.'
   signal _VPAppExit
end

do until ( _VPEventCall=='')
   _VPEventCall = VpGetMsg(_VPAppHandle)
   Interpret _VpEventCall
end
/* Terminate application */
_VPAppExit:
call VpQuit _VPAppHandle
return _VPAppReturn


/* ##256_1000.0 */
256_1000.0: /* Event LEFT LEFT, Clicked/selected */
Arg window self



OldClipboardData = VpWindow(window,'GETCLIPBOARD','TEXT')
LengthOfOldClipboardData = LENGTH(OldClipboardData)
/*Begin finding the positions of the Carriage Return-Line Find (CR-LF) characters*/
Position. = ""
Start = 1
J = 0
DO UNTIL RC = 0 | Start >= LengthOfOldClipboardData
	RC = POS(CRCharacter, OldClipboardData, Start)
	SELECT
		WHEN RC > 0 THEN DO
			J = J + 1
			Position.J = RC
			Start = RC + 1
		END	/*Ends "WHEN RC > 0 THEN DO" Section*/

		WHEN RC = 0 & Start < LengthOfOldClipboardData THEN DO
			J = J + 1
			Position.J = LengthOfOldClipboardData
			Start = LengthOfOldClipboardData + 2
		END	/*Ends "WHEN RC = 0 & Start < LengthOfOldClipboardData THEN DO" Section*/

		OTHERWISE NOP
	END	/*Ends "SELECT" Section*/
END	/*Ends "DO UNTIL RC = 0 | Start > LengthOfOldClipboardData" Section*/
IF J > 0 THEN Position.0 = J
ELSE DO
	Position.0 = 1
	Position.1 = LengthOfOldClipboardData
END	/*Ends "ELSE DO" Section*/
/*End finding the positions of the Carriage Return-Line Find (CR-LF) characters*/



/*Begin Parsing the clipboard contents into separate lines*/
OldClipboardDataLines. = ""
LengthOfOldClipboardDataLines. = ""
Start = 1
DO J = 1 TO Position.0 BY 1
	SELECT
		WHEN J < Position.0 THEN DO
			DesiredLength = Position.J - Start
			OldClipboardDataLines.J = SUBSTR(OldClipboardData, Start, DesiredLength)
			LengthOfOldClipboardDataLines.J = LENGTH(OldClipboardDataLines.J)
			Start = Position.J + 1
		END	/*Ends "WHEN J < Position.0 THEN DO" Section*/

		WHEN J = Position.0 THEN DO
			DesiredLength = LengthOfOldClipboardData - Start + 1
			OldClipboardDataLines.J = SUBSTR(OldClipboardData, Start, DesiredLength)
			LengthOfOldClipboardDataLines.J = LENGTH(OldClipboardDataLines.J)
		END	/*Ends "WHEN J = Position.0 THEN DO" Section*/

		OTHERWISE NOP
	END	/*Ends "SELECT" Section*/
END J	/*Ends "DO J = 1 TO Position.0 BY 1" Section*/
/*End Parsing the clipboard contents into separate lines*/



/*Begin creating the new lines to go into the clipboard*/
NewClipboardDataLines. = ""
DO J = 1 TO Position.0 BY 1
	DesiredLength = LengthOfOldClipboardDataLines.J - 1
	IF DesiredLength > 0 THEN NewClipboardDataLines.J = RIGHT(OldClipboardDataLines.J, DesiredLength)
	ELSE NewClipboardDataLines.J = OldClipboardDataLines.J
END J	/*Ends "DO J = 1 TO Position.0 BY 1" Section*/
/*End creating the new lines to go into the clipboard*/



/*Begin creating the new clipboard contents*/
NewClipboardData = ""
DO J = 1 TO Position.0 BY 1
	SELECT
		WHEN J < Position.0 THEN NewClipboardData = NewClipboardData||NewClipboardDataLines.J||CRCharacter
		WHEN J = Position.0 THEN NewClipboardData = NewClipboardData||NewClipboardDataLines.J
		OTHERWISE NOP
	END
END J	/*Ends "DO J = 1 TO Position.0 BY 1" Section*/
CALL VpWindow window,'SETCLIPBOARD','TEXT',NewClipboardData
/*End creating the new clipboard contents*/
return

/* ##256_1001.0 */
256_1001.0: /* Event RIGHT RIGHT, Clicked/selected */
Arg window self



OldClipboardData = VpWindow(window,'GETCLIPBOARD','TEXT')
LengthOfOldClipboardData = LENGTH(OldClipboardData)
/*Begin finding the positions of the Carriage Return-Line Find (CR-LF) characters*/
Position. = ""
Start = 1
J = 0
DO UNTIL RC = 0 | Start >= LengthOfOldClipboardData
	RC = POS(CRCharacter, OldClipboardData, Start)
	SELECT
		WHEN RC > 0 THEN DO
			J = J + 1
			Position.J = RC
			Start = RC + 1
		END	/*Ends "WHEN RC > 0 THEN DO" Section*/

		WHEN RC = 0 & Start < LengthOfOldClipboardData THEN DO
			J = J + 1
			Position.J = LengthOfOldClipboardData
			Start = LengthOfOldClipboardData + 2
		END	/*Ends "WHEN RC = 0 & Start < LengthOfOldClipboardData THEN DO" Section*/

		OTHERWISE NOP
	END	/*Ends "SELECT" Section*/
END	/*Ends "DO UNTIL RC = 0 | Start > LengthOfOldClipboardData" Section*/
IF J > 0 THEN Position.0 = J
ELSE DO
	Position.0 = 1
	Position.1 = LengthOfOldClipboardData
END	/*Ends "ELSE DO" Section*/
/*End finding the positions of the Carriage Return-Line Find (CR-LF) characters*/



/*Begin Parsing the clipboard contents into separate lines*/
OldClipboardDataLines. = ""
LengthOfOldClipboardDataLines. = ""
Start = 1
DO J = 1 TO Position.0 BY 1
	SELECT
		WHEN J < Position.0 THEN DO
			DesiredLength = Position.J - Start
			OldClipboardDataLines.J = SUBSTR(OldClipboardData, Start, DesiredLength)
			LengthOfOldClipboardDataLines.J = LENGTH(OldClipboardDataLines.J)
			Start = Position.J + 1
		END	/*Ends "WHEN J < Position.0 THEN DO" Section*/

		WHEN J = Position.0 THEN DO
			DesiredLength = LengthOfOldClipboardData - Start + 1
			OldClipboardDataLines.J = SUBSTR(OldClipboardData, Start, DesiredLength)
			LengthOfOldClipboardDataLines.J = LENGTH(OldClipboardDataLines.J)
		END	/*Ends "WHEN J = Position.0 THEN DO" Section*/

		OTHERWISE NOP
	END	/*Ends "SELECT" Section*/
END J	/*Ends "DO J = 1 TO Position.0 BY 1" Section*/
/*End Parsing the clipboard contents into separate lines*/



/*Begin creating the new lines to go into the clipboard*/
NewClipboardDataLines. = ""
DO J = 1 TO Position.0 BY 1
	NewClipboardDataLines.J = " "OldClipboardDataLines.J
END J	/*Ends "DO J = 1 TO Position.0 BY 1" Section*/
/*End creating the new lines to go into the clipboard*/



/*Begin creating the new clipboard contents*/
NewClipboardData = ""
DO J = 1 TO Position.0 BY 1
	SELECT
		WHEN J < Position.0 THEN NewClipboardData = NewClipboardData||NewClipboardDataLines.J||CRCharacter
		WHEN J = Position.0 THEN NewClipboardData = NewClipboardData||NewClipboardDataLines.J
		OTHERWISE NOP
	END
END J	/*Ends "DO J = 1 TO Position.0 BY 1" Section*/
CALL VpWindow window,'SETCLIPBOARD','TEXT',NewClipboardData
/*End creating the new clipboard contents*/
return

/* ##256_1002.0 */
256_1002.0: /* Event CANCEL CANCEL, Clicked/selected */
Arg window self



CALL VpWindow window,'CLOSE'
return

/* ##256_Form.1 */
256_Form.1: /* Event Form events, Opened */
Arg window 



/*Begin registering the REXX Utility functions*/
REXXUtilityFlag = RXFUNCQUERY("SYSLOADFUNCS")
IF REXXUtilityFlag \= 0 THEN DO
	CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
	CALL SysLoadFuncs
END	/*Ends "IF REXXUtilityFlag \= 0 THEN DO" Section*/
/*End registering the REXX Utility functions*/



/*Begin finding the File Spec information on this VisProRexx program and assigning its value to the value, ProgramLocation, here in this program*/
PARSE SOURCE OperatingSystem HowCalled FileSpec
ProgramLocation = ""
FileSpecPortion = FileSpec
DO UNTIL FileSpecPortion = ""
	PARSE Var FileSpecPortion FirstPart "\" SecondPart
	SELECT
		WHEN ProgramLocation = "" & SecondPart \= "" THEN ProgramLocation = FirstPart
		WHEN ProgramLocation \= "" & SecondPart \= "" THEN ProgramLocation = ProgramLocation"\"FirstPart
		OTHERWISE NOP
	END	/*Ends "SELECT" Section*/
	FileSpecPortion = SecondPart
END	/*Ends "DO UNTIL FileSpecPortion = """ Section*/
/*End finding the File Spec information on this VisProRexx program and assigning its value to the value, ProgramLocation, here in this program*/



/*Begin reading the "CR" ASCII file*/
FirstFilePath = ProgramLocation"\SubProcs\CR"
CRCharacter = CHARIN(FirstFilePath, 2)
RC = LINEOUT(FirstFilePath)
/*End reading the "CR" ASCII file*/

return

/* ##SUB_CR */
CR: 

return

/* ##SUB_TestLines */
TestLines: This is line 1
This is line 2
This is line 3
return
